/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is EM Menu.
 *
 * The Initial Developer of the Original Code is
 * Devon Jensen.
 *
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Devon Jensen <velcrospud@hotmail.com>
 *
 * configure.png (wrench icon) is from Crystal SVG icon set by Everaldo
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

window.addEventListener("load", emmenu_init, true);
var emmenu_ExtensionManager;
var emmenu_loaded = false;

function emmenu_init() {
	if(emmenu_loaded) return;
	emmenu_loaded = true;
	
	//var ExtElem = document.getElementsByAttribute("command", "Tools:Extensions");
	//ExtElem[0].hidden = "true";	
	
	emmenu_ExtensionManager = Components.classes["@mozilla.org/extensions/manager;1"]
                                .getService(Components.interfaces.nsIExtensionManager);
                                
    document.getElementById("exMgrMenuPopup").database.AddDataSource(emmenu_ExtensionManager.datasource);
	document.getElementById("exMgrMenuPopup").builder.rebuild();
	
	// Developer features to be disabled
	//toJavaScriptConsole();
	//BrowserOpenExtensions('extensions');
	//document.getElementById("menu_FilePopup").parentNode.setAttribute("onclick", "if(event.button == 1) goQuitApplication();");
}

function emmenu_fixPopupOnShow(elem) {
	
	// Start out with Options disabled, only enable if ex is enabled and has options
	document.getElementById("emmenu_openOptionsItem").setAttribute("disabled", "true");
	
	if(elem.getAttribute("isDisabled")) {
		document.getElementById("emmenu_enableItem").hidden = false;
		document.getElementById("emmenu_disableItem").hidden = true;
		
	}
	else {  // not disabled
		document.getElementById("emmenu_disableItem").hidden = false;
		document.getElementById("emmenu_enableItem").hidden = true;
		if(elem.getAttribute("optionsURL") != "")
			document.getElementById("emmenu_openOptionsItem").setAttribute("disabled", "false");
	}
	
	if(elem.getAttribute("optype") == "needs-disable" | elem.getAttribute("optype") == "needs-uninstall") {
		document.getElementById("emmenu_enableItem").hidden = false;
		document.getElementById("emmenu_disableItem").hidden = true;
	}
	
	if(elem.getAttribute("optype") == "needs-enable") {
		document.getElementById("emmenu_disableItem").hidden = false;
		document.getElementById("emmenu_enableItem").hidden = true;
	}
	
	if(elem.getAttribute("homepageURL") == "")
		document.getElementById("emmenu_openHomepageItem").setAttribute("disabled", "true");
	else
		document.getElementById("emmenu_openHomepageItem").setAttribute("disabled", "false");
}

function emmenu_setupMenu() {
	
	var exts = document.getElementById("exMgrMenuPopup").childNodes;
	// Load localized strings
	var emmenu_strings = document.getElementById("emmenubundle");
	

	for(var i=0; i<exts.length; ++i) {
		if(exts[i].getAttribute("name") != "") {

			var optype = exts[i].getAttribute("optype");
			if(optype == "needs-disable") {
				exts[i].lastChild.setAttribute("src", "chrome://emmenu/content/grayCircle.png");
				exts[i].setAttribute("tooltiptext", emmenu_strings.getString("disable"));
			}	
			if(optype == "needs-uninstall") {
				exts[i].lastChild.setAttribute("src", "chrome://emmenu/content/redCircle.png");				
				exts[i].setAttribute("tooltiptext", emmenu_strings.getString("uninstall"));
			}
			if(optype == "needs-enable" | optype == "needs-install") {
				exts[i].lastChild.setAttribute("src", "chrome://emmenu/content/greenCircle.png");
				exts[i].setAttribute("tooltiptext", emmenu_strings.getString("enable"));
			}
			if(optype == "none" && exts[i].getAttribute("hasUpdateAvailable") != "") {
				exts[i].lastChild.setAttribute("src", "chrome://emmenu/content/blueCircle.png");
				exts[i].setAttribute("tooltiptext", emmenu_strings.getString("update"));
			}
			if(optype == "none" && exts[i].getAttribute("hasUpdateAvailable") == ""){
				exts[i].lastChild.setAttribute("src", "");
			}
			if(exts[i].getAttribute("optionsURL") != "" && !exts[i].getAttribute("isDisabled")) {
				exts[i].firstChild.nextSibling.nextSibling.nextSibling.setAttribute("src", "chrome://emmenu/content/configure.png");
			}
			
		}
	}
	
	// Have to add these after the template has run or they will always show up at the top
	// removed from list:  "emmenu_sep1", "emmenu_openEMWin", 
	var addonItems=["emmenu_sep2", "emmenu_enAll", "emmenu_disAll"];
	var tempitem;
	for(var j=0; j<addonItems.length; ++j) {
		tempitem = document.getElementById(addonItems[j]);
		document.getElementById("exMgrMenuPopup").appendChild(tempitem);
	}
}

function emmenu_destroyMenu() {
	
	// put the static elements back on the temp menu holder
	// removed from list:  "emmenu_sep1", "emmenu_openEMWin", 
	var addonItems=["emmenu_sep2", "emmenu_enAll", "emmenu_disAll"];
	var tempitem;
	for(var j=0; j<addonItems.length; ++j) {
		tempitem = document.getElementById(addonItems[j]);
		document.getElementById("emmenu_tempStorage").appendChild(tempitem);
	}
}

function emmenu_hidePopup() {

	document.getElementById("exMgrMenuPopup").hidePopup();
	document.getElementById("menu_ToolsPopup").hidePopup();
	document.getElementById("menu_FilePopup").hidePopup();
	
}

function emmenu_enableAll() {

	var exts = document.getElementById("exMgrMenuPopup").childNodes;
	
	for(var i=0; i<exts.length; ++i) {
		if(exts[i].getAttribute("name") != "")  // Only the generated ext menuitems have the name attribute
			emmenu_enableOne(exts[i]);
	}
}

function emmenu_disableAll() {
	
	var exts = document.getElementById("exMgrMenuPopup").childNodes;
	
	for(var i=0; i<exts.length; ++i) {
		var name = exts[i].getAttribute("name");
		if(name != "" && name != "EM Menu")  // Only the generated ext menuitems have the name attribute
			emmenu_disableOne(exts[i]);
	}
}

function emmenu_openOptions(elem) {
	var optionsURL = elem.getAttribute("optionsURL");
	if(optionsURL == "")
		emmenu_openAbout(elem);
	else
		toOpenWindowByType('extension:options', optionsURL, "left=100,top=100,chrome,extrachrome,menubar,resizable,scrollbars,status,toolbar");
}

function emmenu_openHomepage(elem) {
	
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService();
    var wmed = wm.QueryInterface(Components.interfaces.nsIWindowMediator);
    
    var win = wmed.getMostRecentWindow("navigator:browser");
    if (!win)
    	win = window.openDialog("chrome://browser/content/browser.xul", "_blank", "chrome,all,dialog=no", "about:blank", null, null);
    
    var content = win.document.getElementById("content");
    content.selectedTab = content.addTab(elem.getAttribute('homepageURL'));
	
}

function emmenu_openAbout(elem) {

	emmenu_hidePopup();
	var aboutURL = elem.getAttribute("aboutURL");
      if (aboutURL != "")
        openDialog(aboutURL, "", "chrome");
      else
        openDialog("chrome://mozapps/content/extensions/about.xul", "", "chrome", elem.id, document.getElementById("exMgrMenuPopup").database);
	
}

function emmenu_disableOne(elem) {
	emmenu_ExtensionManager.disableItem(emmenu_getIDFromResourceURI(elem.id));
	
}

function emmenu_enableOne(elem) {
	emmenu_ExtensionManager.enableItem(emmenu_getIDFromResourceURI(elem.id));
	
}

function emmenu_uninstall(elem) {
	emmenu_ExtensionManager.uninstallItem(emmenu_getIDFromResourceURI(elem.id));
	
}

function emmenu_updateOne(elem) {
	var id = emmenu_getIDFromResourceURI(elem.id);
	items = [emmenu_ExtensionManager.getItemForID(id)];
	//var listener = new UpdateCheckListener();
    emmenu_ExtensionManager.update(items, items.length, false, null);
	
}

// From Firefox EM in 1.5beta1
function emmenu_getIDFromResourceURI(aURI) {
  var PREFIX_ITEM_URI = "urn:mozilla:item:";
  if (aURI.substring(0, PREFIX_ITEM_URI.length) == PREFIX_ITEM_URI) 
    return aURI.substring(PREFIX_ITEM_URI.length);
  return aURI;
}

// Dump a message to Javascript Console
/*
function d(msg){
	var acs = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
	acs.logStringMessage(msg);
}
*/